Loading...
More C++ Posts
//Leif Messinger//Finds all sets of 5 5 letter words that don't have duplicate letters in either themselves or each other.//First it reads the words in and puts them in groups of their bitmasks//After that, we recurse on each group. Before doing that, we remove the group from the set of other groups to check it against.#include <cstdio> //getchar, printf#include <cassert> //assert#include <vector>#include <set>#include <algorithm> //std::copy_if#include <iterator> //std::back_inserter#define CHECK_FOR_CRLF true#define MIN_WORDS 5#define MAX_WORDS 5#define WORD_TOO_LONG(len) (len != 5)const unsigned int charToBitmask(const char bruh){assert(bruh >= 'a' && bruh <= 'z');return (1 << (bruh - 'a'));}void printBitmask(unsigned int bitmask){char start = 'a';while(bitmask != 0){if(bitmask & 1){putchar(start);}bitmask >>= 1;++start;}}//Pointer needs to be deletedconst std::set<unsigned int>* getBitmasks(){std::set<unsigned int>* bitmasksPointer = new std::set<unsigned int>;std::set<unsigned int>& bitmasks = (*bitmasksPointer);unsigned int bitmask = 0;unsigned int wordLength = 0;bool duplicateLetters = false;for(char c = getchar(); c >= 0; c = getchar()){if(CHECK_FOR_CRLF && c == '\r'){continue;}if(c == '\n'){if(!(WORD_TOO_LONG(wordLength) || duplicateLetters)) bitmasks.insert(bitmask);bitmask = 0;wordLength = 0;duplicateLetters = false;continue;}if((bitmask & charToBitmask(c)) != 0) duplicateLetters = true;bitmask |= charToBitmask(c);++wordLength;}return bitmasksPointer;}void printBitmasks(const std::vector<unsigned int>& bitmasks){for(unsigned int bruh : bitmasks){printBitmask(bruh);putchar(','); putchar(' ');}puts("");}//Just to be clear, when I mean "word", I mean a group of words with the same letters.void recurse(std::vector<unsigned int>& oldBitmasks, std::vector<unsigned int> history, const unsigned int currentBitmask){//If there's not enough words leftif(oldBitmasks.size() + (-(history.size())) + (-MIN_WORDS) <= 0){//If there's enough wordsif(history.size() >= MIN_WORDS){//Print the listprintBitmasks(history);}return;//To make it faster, we can stop it after 5 words too}else if(history.size() >= MAX_WORDS){//Print the listprintBitmasks(history);return;}//Thin out the array with only stuff that matches the currentBitmask.std::vector<unsigned int> newBitmasks;std::copy_if(oldBitmasks.begin(), oldBitmasks.end(), std::back_inserter(newBitmasks), [¤tBitmask](unsigned int bruh){return (bruh & currentBitmask) == 0;});while(newBitmasks.size() > 0){//I know this modifies 'oldBitmasks' too. It's intentional.//This makes it so that the word is never involved in any of the child serches or any of the later searches in this while loop.const unsigned int word = newBitmasks.back(); newBitmasks.pop_back();std::vector<unsigned int> newHistory = history;newHistory.push_back(word);recurse(newBitmasks, newHistory, currentBitmask | word);}}int main(){const std::set<unsigned int>* bitmasksSet = getBitmasks();std::vector<unsigned int> bitmasks(bitmasksSet->begin(), bitmasksSet->end());delete bitmasksSet;recurse(bitmasks, std::vector<unsigned int>(), 0);return 0;}
/*Good morning! Here's your coding interview problem for today.This problem was asked by LinkedIn.A wall consists of several rows of bricks of various integer lengths and uniform height. Your goal is to find a vertical line going from the top to the bottom of the wall that cuts through the fewest number of bricks. If the line goes through the edge between two bricks, this does not count as a cut.For example, suppose the input is as follows, where values in each row represent the lengths of bricks in that row:[[3, 5, 1, 1],[2, 3, 3, 2],[5, 5],[4, 4, 2],[1, 3, 3, 3],[1, 1, 6, 1, 1]]The best we can we do here is to draw a line after the eighth brick, which will only require cutting through the bricks in the third and fifth row.Given an input consisting of brick lengths for each row such as the one above, return the fewest number of bricks that must be cut to create a vertical line.AUTHORS NOTE:Makes following assumptions:- Each row is same length- Data is in file called "data.dat" and formatted in space-separated rows- The cuts at the beginning and end of the wall are not solutionsThis requires the following file named data.dat that is a space separated file, or similar formatted file:----START FILE----3 5 1 12 3 3 25 54 4 21 3 3 31 1 6 1 1----END FILE----*/#include <algorithm>#include <iostream>#include <fstream>#include <map>#include <sstream>#include <string>#include <vector>using namespace std;int main(){vector<vector<int>> wall;ifstream in;in.open("data.dat");if(!in.good()){cout << "ERROR: File failed to open properly.\n";}/* Get input from space separated file */string line;while(!in.eof()){getline(in, line);int i;vector<int> currv;stringstream strs(line);while(strs >> i)currv.push_back(i);wall.push_back(currv);}/* Convert each value from "length of brick" to "position at end of brick" */for(int y = 0; y < wall.size(); y++){wall.at(y).pop_back(); //Delet last valfor(int x = 1; x < wall.at(y).size(); x++) //Skip the first bc data doesn't need changewall.at(y).at(x) += wall.at(y).at(x-1);}/* Check output. COMMENT OUT */// for(auto row : wall)// {// for(int pos : row)// cout << pos << " ";// cout << endl;// }/* Determine which ending position is most common, and cut there *///Exclude final position, which will be the size of the wallint mode = -1;int amt = -1;vector<int> tried;for(auto row : wall){for(int pos : row) //For each pos in the wall{//Guard. If pos is contained in the list, skip posif(find(tried.begin(), tried.end(), pos) != tried.end())continue;tried.push_back(pos);/* Cycle through each row to see if it contains the pos */int curramt = 0;for(auto currrow : wall){if( find( currrow.begin(), currrow.end(), pos ) != currrow.end() )curramt++;}//cout << pos << " " << curramt << endl;if(curramt > amt){amt = curramt;mode = pos;}}}cout << "Please cut at position " << mode << endl;cout << "This will cut through " << (wall.size() - amt) << " bricks." << endl;return 0;}
/*this program will simulate the spreading of a disease through agrid of people, starting from a user-defined person. It will countthe number of turns taken before everyone on the grid is immunizedto the disease after having caught it once.This program will user the SIR model (Susceptible, Infectious, Recovered)and cellular automata to simulate the people in the grid.*/#include <iostream>using namespace std;/* Any and all global variables */const int SIZE = 8; //Size of the square person array/* Any and all functions */void gridDefaultify(char[][SIZE], int);//Purpose: Sets each item in the person array to 's'//Parameters: A square, two-dimensional array// The size of that array's boundsvoid gridDisplay(char[][SIZE], int);//Purpose: Formats and prints the information in the person grid//Parameters: A square, two-dimensional array// The value of the current dayvoid nextTurn(char[][SIZE], char[][SIZE], int&);//Purpose: Updates the grid of people, and the current day//Parameters: Two square, two-dimensional arrays// A reference to the current day (so that it can be updated)int countInfected(char[][SIZE], int);//Purpose: Counts the number of infectious people on the grid//Parameters: A square, two-dimensional array// The size of that array's boundsint main(){int currentDay = 0; //Infection begins on day 0, and ends one day after the last person is Recoveredchar gridCurrent[SIZE][SIZE]; //Grid of all peoplechar gridUpdate[SIZE][SIZE]; //Where the user chooses to start the infectionint xToInfect;int yToInfect; //Set of coordinates for the initial infection position, given by user//Initializes the grids to all 's'gridDefaultify(gridCurrent, SIZE);gridDefaultify(gridUpdate, SIZE);//The below block gets the initial infection coordinates from the usercout << "Please enter a location to infect: ";while(true){cin >> xToInfect >> yToInfect;xToInfect--;yToInfect--;if(xToInfect < 0 || yToInfect < 0 || xToInfect >= SIZE || yToInfect >= SIZE){cout << "Those coordinates are outside the bounds of this region." << endl;cout << "Please enter another location to infect: ";continue;} else {gridCurrent[xToInfect][yToInfect] = 'i';break;}}//Displays the initial state of the gridgridDisplay(gridCurrent, currentDay);//The below block will display and update the grid until the infection is done.while(true){nextTurn(gridCurrent, gridUpdate, currentDay);gridDisplay(gridCurrent, currentDay);if(countInfected(gridCurrent, SIZE) == 0) break; //Once there are no more infected, the game is done}//Displays the number of days taken for the infection to endcout << "It took " << currentDay + 1 << " days for the outbreak to end";cout << endl;return 0;}void gridDefaultify(char arr[][SIZE], int arrSize){for(int x = 0; x < arrSize; x++){for(int y = 0; y < arrSize; y++){arr[x][y] = 's'; //Sets all items in the passed-in array to 's'}}return;}void gridDisplay(char arr[][SIZE], int day){cout << "Day " << day << endl; //Prints the current dayfor(int x = 0; x < SIZE; x++){for(int y = 0; y < SIZE; y++){cout << arr[x][y] <<" "; //Prints the array's contents}cout << endl; //Formats with newlines}cout << endl; //Some spacingreturn;}void nextTurn(char today[][SIZE], char update[][SIZE], int& day){day++; //Updates the dayint xCheck; //X coordinate to be checkedint yCheck; //Y coordinate to be checkedfor(int x = 0; x < SIZE; x++){for(int y = 0; y < SIZE; y++){//Sets all 'i' to 'r' in the new gridif(today[x][y] == 'i' || today[x][y] == 'r'){update[x][y] = 'r'; //Updates all infectious to recovered, and keeps current recovered}if(today[x][y] == 's'){ // If the person is susceptible...for(int xCheck = x-1; xCheck <= x+1; xCheck++){ // Check all x coordinates around the personfor(int yCheck = y-1; yCheck <= y+1; yCheck++){ // Check all y coordinates around the personif(xCheck == x && yCheck == y){// Don't check at the person because there is no need to check there} else {if(xCheck >= 0 && yCheck >= 0 && xCheck < SIZE && yCheck < SIZE){ // Make sure the checked coordinates are in boundsif(today[xCheck][yCheck] == 'i'){ //Is the person at the checked coordinates infected?update[x][y] = 'i'; //If so, update the 's' to 'i' in the new grid}}}}}}}}for(int x = 0; x < SIZE; x++){for(int y = 0; y < SIZE; y++){today[x][y] = update[x][y]; //Updates today's grid with the new values}}}int countInfected(char arr[][SIZE], int arrSize){int count = 0;for(int x = 0; x < arrSize; x++){for(int y = 0; y < arrSize; y++){if(arr[x][y] == 'i') count++; //Increments count for each infected person in the grid}}return count;}
#include <iostream>using namespace std;int main() {const int ROW_SIZE = 2;const int COLUMN_SIZE = 5; //establish all variablesint matrix[ROW_SIZE][COLUMN_SIZE];int minVal;for (int i = 0; i < ROW_SIZE; ++i) // for loop to ask user to enter data.{for (int h = 0; h < COLUMN_SIZE; ++h) {cout << "Enter data for row #" << i + 1 << " and column #" << h + 1 << ": ";cin >> matrix[i][h];}}cout << "You entered: " << endl;for (int i = 0; i < ROW_SIZE; ++i) //for statements to output the array neatly{for (int h = 0; h < COLUMN_SIZE; ++h) {cout << matrix[i][h] << "\t";}cout << endl;}cout << "Minimum for each row is: {";for (int i = 0; i < ROW_SIZE; i++) //for statements to find the minimum in each row{minVal = matrix[i][0];for (int h = 0; h < COLUMN_SIZE; h++) {if (matrix[i][h] < minVal) // if matrix[i][h] < minVal -> minVal = matrix[i][h];{minVal = matrix[i][h];}}cout << minVal << ", ";}cout << "}" << endl;cout << "Minimum for each column is: {";for (int i = 0; i < COLUMN_SIZE; i++) //for statements to find the minimum in each column{minVal = matrix[0][i];for (int h = 0; h < ROW_SIZE; h++) {if (matrix[h][i] < minVal) //replaces minVal with array index for that column that is lowest{minVal = matrix[h][i];}}cout << minVal << ", ";}cout << "}" << endl;return 0;}
//Leif Messinger//Compile with C++ 20#include <iostream>#include <ranges>#include <vector>#include <functional>#include <cctype> //toupper#include <cxxabi.h>template <typename T>void printType(){std::cout << abi::__cxa_demangle(typeid(T).name(), NULL, NULL, NULL) << std::endl;}template <typename T>class Slicer{public:T begin_;T end_;T trueEnd;Slicer(T begin, T end): begin_(begin), end_(begin), trueEnd(end){}template<typename U>Slicer(U&& vec) : begin_(vec.begin()), end_(vec.begin()), trueEnd(vec.end()){}Slicer& finish(){begin_ = end_;end_ = trueEnd;return (*this);}Slicer& to(long int index){begin_ = end_;if(index > 0){end_ = (begin_ + index);}else{index *= -1;end_ = (trueEnd - index);}return (*this);}Slicer& operator[](long int index){return to(index);}T begin(){return this->begin_;}T end(){return this->end_;}Slicer& operator()(std::function<void(decltype(*begin_))> func) {for(decltype(*begin_) thing : (*this)){func(thing);}return (*this);}};static_assert(std::ranges::range< Slicer<std::vector<int>::const_iterator> >);int main(){std::string vec = "abcdefghijklmnopqrstuvwxyz";Slicer<std::string::const_iterator> bruh(vec);//printType<decltype(bruh)>();bruh.to(3)([](char yeet){std::cout << yeet;}).to(-1)([](char yeet){std::cout << char(std::toupper(yeet));}).finish()([](char yeet){std::cout << yeet << yeet << yeet << yeet << yeet;});std::cout << std::endl << std::endl;int arr[] = {1, 2, 3, 4, 5, 6, 7, 8};Slicer<int*> arrSlicer(arr, arr + (sizeof(arr)/sizeof(int)));std::cout << "[";arrSlicer.to(-1)([](int yeet){std::cout << yeet << ", ";}).finish()([](int yeet){std::cout << yeet << "]" << std::endl;});return 0;}
#include <iostream>int main(){const char* const hello = "Hello, world!";const char* bruh = hello;char* const yeet = hello;std::cout << bruh << std::endl;std::cout << yeet << std::endl;return 0;}/*Place your bets!Will the program:a.) Print "Hello, world!" twice?b.) Compile error on line 5 (bruh initialize line) because the pointer gets implicit cast to non-const?c.) Compile error on line 7 (yeet initialize line) because the char gets implicit cast to non-const?d.) Both b and c?e.) Compile error line 11 (print yeet) because the pointer is constant and can't be incrementedf.) Print "Hello, world!" then print the pointer address in hexadecimalg.) Both b and e?h.) Both c and e?i.) B, c, and e?*/// The answer is in this base 64 string:// T25seSBjLikKVGhlIGNvbXBpbGVyIGRvZXNuJ3QgYXBwcmVjaWF0ZSB5b3UgbWFraW5nIHRoZSBjaGFyYWN0ZXJzIHRoZSBwb2ludGVyIHJlZmVycyB0byBub24tY29uc3QsIGJ1dCBpdCdzIGZpbmUgd2l0aCB5b3UgY29weWluZyBhIGNvbnN0YW50IHZhbHVlLCBpLmUuIHRoZSBwb2ludGVyLCB0byBhIG5vbi1jb25zdGFudCB2YXJpYWJsZS4KSWYgeW91IHJlcGxhY2UgdGhhdCBsaW5lIHdpdGggY2hhciogY29uc3QgeWVldCA9IGNvbnN0X2Nhc3Q8Y2hhciogY29uc3Q+KGhlbGxvKTsgSXQnbGwgcHJpbnQgIkhlbGxvLCB3b3JsZCEiIHR3aWNlLCB3aGljaCBpcyB2ZXJ5IHN0cmFuZ2UgY29uc2lkZXJpbmcgdGhhdCB5ZWV0IGlzIGEgY29uc3QgcG9pbnRlciwgc28geW91J2QgdGhpbmsgaXQgd291bGQgcHJpbnQgYXMgYSBoZXhhZGVjaW1hbCBiZWNhdXNlIGlmIHlvdSB0cnkgdG8gKCsreWVldCkgd2hpbGUgbG9vcGluZyB0aHJvdWdoIHRoZSBzdHJpbmcsIHlvdSdkIGdldCBhbiBlcnJvciwgYmVjYXVzZSBpdCdzIGNvbnN0IGFuZCBjYW4ndCBiZSBjaGFuZ2VkLgpJbnN0ZWFkIG9mIHVzaW5nIGEgdGVtcGxhdGUgZnVuY3Rpb24gZm9yIG9zdHJlYW06Om9wZXJhdG9yPDwsIHRoZXkgbWFrZSBpdCBhIGZ1bmN0aW9uIHRoYXQgdGFrZXMgdHlwZSBjb25zdCBjaGFyKiwgYW5kIEMrKyBoYXMgbm8gcHJvYmxlbXMgcHJvbW90aW5nIGEgdmFyaWFibGUgdG8gY29uc3RhbnQgd2hlbiBpbXBsaWNpdCBjYXN0aW5nLCBhbmQgaXQgaGFzIG5vIHByb2JsZW1zIGltcGxpY2l0IGNhc3RpbmcgdGhlIGNvbnN0IHBvaW50ZXIgdG8gYSBub3JtYWwgcG9pbnRlciBiZWNhdXNlIGl0J3MgbWFraW5nIGEgY29weS4gVGhlIHBvaW50ZXIgZ2V0cyBjb3BpZWQgYmVjYXVzZSB0aGUgcG9pbnRlciBpcyBwYXNzZWQgYnkgdmFsdWUsIG5vdCByZWZlcmVuY2Uu